package com.qmth.distributed.print.api;

import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.distributed.print.business.service.ActivitiService;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * @Description: activiti demo api
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/7/12
 */
@Api(tags = "工作流Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/${prefix.url.basic}/activiti")
public class ActivitiController {

    @Resource
    private ActivitiService activityConsumerService;

    @ApiOperation(value = "注册流程")
    @RequestMapping(value = "/createDeployment", method = RequestMethod.POST)
    public Result createDeployment(@RequestParam(value = "processFileName") String processFileName) {
        activityConsumerService.createDeployment(processFileName);
        return ResultUtil.ok();
    }

    @ApiOperation(value = "启动流程")
    @RequestMapping(value = "/startActivityDemo", method = RequestMethod.POST)
    public Result startActivityDemo(@RequestParam(value = "processKey") String processKey) {
        activityConsumerService.startActivityDemo(processKey);
        return ResultUtil.ok();
    }

    @ApiOperation(value = "获取待办")
    @RequestMapping(value = "/getTaskList", method = RequestMethod.POST)
    public Result getTaskList() {
        activityConsumerService.getTaskList();
        return ResultUtil.ok();
    }

    @ApiOperation(value = "提交")
    @RequestMapping(value = "/complete", method = RequestMethod.POST)
    public Result complete(@RequestParam(value = "taskId") String taskId) {
        activityConsumerService.complete(taskId);
        return ResultUtil.ok();
    }

    @ApiOperation(value = "根据流程id直接结束流程")
    @RequestMapping(value = "/deleteProcessInstance", method = RequestMethod.POST)
    public Result deleteProcessInstance(@RequestParam(value = "flowId") String flowId) {
        activityConsumerService.deleteProcessInstance(flowId);
        return ResultUtil.ok();
    }
}